"{ Package: 'stx:libjava/tools' }"

ApplicationModel subclass:#JavaCodeBundleEditor
	instanceVariableNames:'bundleHolder readonlyHolder bundleTree bundleTreeSelectionHolder'
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Java-Tools'
!

HierarchicalItem subclass:#Item
	instanceVariableNames:'libraryOrBundle'
	classVariableNames:''
	poolDictionaries:''
	privateIn:JavaCodeBundleEditor
!


!JavaCodeBundleEditor class methodsFor:'interface specs'!

windowSpec
    "This resource specification was automatically generated
     by the UIPainter of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the UIPainter may not be able to read the specification."

    "
     UIPainter new openOnClass:JavaCodeBundleEditor andSelector:#windowSpec
     JavaCodeBundleEditor new openInterface:#windowSpec
     JavaCodeBundleEditor open
    "

    <resource: #canvas>

    ^ 
     #(FullSpec
        name: windowSpec
        window: 
       (WindowSpec
          label: 'NewApplication'
          name: 'NewApplication'
          bounds: (Rectangle 0 0 300 300)
        )
        component: 
       (SpecCollection
          collection: (
           (HierarchicalListViewSpec
              name: 'HierarchicalListView1'
              layout: (LayoutFrame 0 0 0 0 0 1 0 1)
              model: bundleTreeSelectionHolder
              hasHorizontalScrollBar: true
              hasVerticalScrollBar: true
              listModel: bundleTree
              useIndex: false
              highlightMode: line
              useDefaultIcons: false
            )
           )
         
        )
      )
! !

!JavaCodeBundleEditor class methodsFor:'plugIn spec'!

aspectSelectors
    ^#(
        bundleHolder
        readonlyHolder
    )

    "Created: / 25-01-2013 / 22:18:03 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 28-01-2013 / 19:30:04 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!JavaCodeBundleEditor methodsFor:'accessing'!

bundle: aJavaCodeBundle
    self bundleHolder value: aJavaCodeBundle

    "Created: / 25-01-2013 / 21:50:25 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!JavaCodeBundleEditor methodsFor:'aspects'!

bundleHolder
    "return/create the 'bundleHolder' value holder (automatically generated)"

    bundleHolder isNil ifTrue:[
        bundleHolder := ValueHolder new.
        bundleHolder addDependent:self.
    ].
    ^ bundleHolder
!

bundleHolder:something
    "set the 'bundleHolder' value holder (automatically generated)"

    |oldValue newValue|

    bundleHolder notNil ifTrue:[
        oldValue := bundleHolder value.
        bundleHolder removeDependent:self.
    ].
    bundleHolder := something.
    bundleHolder notNil ifTrue:[
        bundleHolder addDependent:self.
    ].
    newValue := bundleHolder value.
    oldValue ~~ newValue ifTrue:[
        self update:#value with:newValue from:bundleHolder.
    ].
!

bundleTree
    <resource: #uiAspect>

    "automatically generated by UIPainter ..."

    "*** the code below creates a default model when invoked."
    "*** (which may not be the one you wanted)"
    "*** Please change as required and accept it in the browser."
    "*** (and replace this comment by something more useful ;-)"

    bundleTree isNil ifTrue:[
        bundleTree := HierarchicalList new.
        bundleTree showRoot: false.
    ].
    ^ bundleTree.

    "Modified: / 28-01-2013 / 20:35:11 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

bundleTreeSelectionHolder
    <resource: #uiAspect>

    "automatically generated by UIPainter ..."

    "*** the code below creates a default model when invoked."
    "*** (which may not be the one you wanted)"
    "*** Please change as required and accept it in the browser."
    "*** (and replace this comment by something more useful ;-)"

    bundleTreeSelectionHolder isNil ifTrue:[
        bundleTreeSelectionHolder := ValueHolder new.
"/ if your app needs to be notified of changes, uncomment one of the lines below:
"/       bundleTreeSelectionHolder addDependent:self.
"/       bundleTreeSelectionHolder onChangeSend:#bundleTreeSelectionHolderChanged to:self.
    ].
    ^ bundleTreeSelectionHolder.
!

readonlyHolder
    "return/create the 'readonlyHolder' value holder (automatically generated)"

    readonlyHolder isNil ifTrue:[
        readonlyHolder := ValueHolder with: false.
    ].
    ^ readonlyHolder

    "Modified: / 28-01-2013 / 19:27:29 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

readonlyHolder:something
    "set the 'readonlyHolder' value holder (automatically generated)"

    readonlyHolder := something.
! !

!JavaCodeBundleEditor methodsFor:'change & update'!

update:aspect with: parameter from:changedObject
    "Invoked when an object that I depend upon sends a change notification."

    changedObject == bundleHolder ifTrue:[
        self updateTree.
        ^ self.
    ].
    super update:aspect with:parameter from:changedObject

    "Modified: / 25-01-2013 / 21:40:54 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

updateTree
    self bundleTree root:
        (Item libraryOrBundle: self bundleHolder value parent: nil).
    self bundleTree root expand.

    "Created: / 25-01-2013 / 21:40:54 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 28-01-2013 / 20:35:42 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!JavaCodeBundleEditor::Item class methodsFor:'instance creation'!

libraryOrBundle: model parent: parent
    ^self new
        libraryOrBundle: model;
        parent: parent

    "Created: / 25-01-2013 / 21:53:48 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!JavaCodeBundleEditor::Item methodsFor:'accessing'!

icon
    ^nil

    "Created: / 25-01-2013 / 21:51:55 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

label
    ^libraryOrBundle name

    "Created: / 25-01-2013 / 21:41:38 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

libraryOrBundle
    ^ libraryOrBundle
!

libraryOrBundle:something
    libraryOrBundle := something.
! !

!JavaCodeBundleEditor::Item methodsFor:'protocol-accessing'!

fetchChildren
    ^libraryOrBundle isBundle ifTrue:[
        libraryOrBundle libraries collect:[:each|self class libraryOrBundle:each parent: self]. 
    ] ifFalse:[
        #()
    ]

    "Created: / 25-01-2013 / 21:52:12 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!JavaCodeBundleEditor class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

